searchNodes=[{"doc":"Behaviour for the callback module that implements various tasks for WaxAPIREST.Plug Note that users shall be authenticated in some manner when registering - relying on the provided username would be insecure as it would allow an attacker to register new key (and then authenticate) for any existing account.","ref":"WaxAPIREST.Callback.html","title":"WaxAPIREST.Callback","type":"behaviour"},{"doc":"Returns the current challenge If a fault occurs an exception can be raised. Its error message will be displayed in the JSON error response.","ref":"WaxAPIREST.Callback.html#c:get_challenge/1","title":"WaxAPIREST.Callback.get_challenge/1","type":"callback"},{"doc":"Callback called on Plug.Conn.t/0 upon successful authentication Can be used to set a value (cookie...) in the connection. Signature counter update should be performed at this step, if supported. If a fault occurs an exception can be raised. Its error message will be displayed in the JSON error response.","ref":"WaxAPIREST.Callback.html#c:on_authentication_success/3","title":"WaxAPIREST.Callback.on_authentication_success/3","type":"callback"},{"doc":"Save the current attestation or authentication challenge and returns the connection If a fault occurs an exception can be raised. Its error message will be displayed in the JSON error response.","ref":"WaxAPIREST.Callback.html#c:put_challenge/2","title":"WaxAPIREST.Callback.put_challenge/2","type":"callback"},{"doc":"Saves a new attestation key for a user The COSE key can be retrieved in the authenticator data using: authenticator_data . attested_credential_data . credential_public_key The COSE key is a map of integers (both keys and values). This can be conveniently saved in Erlang / Elixir using Erlang's term_to_binary/1 function (and possibly Base.encode64/1 if the database doesn't accept binary values). The signature count can also be checked against the value saved in the database: authenticator_data . sign_count A single user can register several keys. Each key is identified by its key_id . It returns the connection. This can be used to set a value (cookie...) in it. If a fault occurs an exception can be raised. Its error message will be displayed in the JSON error response.","ref":"WaxAPIREST.Callback.html#c:register_key/4","title":"WaxAPIREST.Callback.register_key/4","type":"callback"},{"doc":"Returns the user info required for WebAuthn This callback is called during attestation and authentication option request and must return the identifier of the user. This identifier is the user handle of the user account entity . As stated by the specification : A user handle is an opaque byte sequence with a maximum size of 64 bytes. User handles are not meant to be displayed to users. The user handle SHOULD NOT contain personally identifying information about the user, such as a username or e-mail address; The callback shall, however, return a string and not a binary as it will not be converted to a string. It can also returns the name and display name of the user (see WaxAPIREST.Callback.user_info/0 ). If not provided, it will be defaulted to the request's values. If the user doesn't exist or a fault occurs when retrieving user information, an exception can be raised. Its error message will be displayed in the JSON error response.","ref":"WaxAPIREST.Callback.html#c:user_info/1","title":"WaxAPIREST.Callback.user_info/1","type":"callback"},{"doc":"Returns the user keys If a fault occurs an exception can be raised. Its error message will be displayed in the JSON error response.","ref":"WaxAPIREST.Callback.html#c:user_keys/1","title":"WaxAPIREST.Callback.user_keys/1","type":"callback"},{"doc":"Key data","ref":"WaxAPIREST.Callback.html#t:key_data/0","title":"WaxAPIREST.Callback.key_data/0","type":"type"},{"doc":"User information The returned id field must be URL base64 encoded no longer than 64 bytes.","ref":"WaxAPIREST.Callback.html#t:user_info/0","title":"WaxAPIREST.Callback.user_info/0","type":"type"},{"doc":"List of registered user keys","ref":"WaxAPIREST.Callback.html#t:user_keys/0","title":"WaxAPIREST.Callback.user_keys/0","type":"type"},{"doc":"A plug that exposes the FIDO2 REST API 7. Transport Binding Profil . Usage In a Phoenix router, forward a route to the WaxAPIREST.Plug : defmodule MyApp.Router do use Phoenix.Router forward &quot;/webauthn&quot; , WaxAPIREST.Plug , callback : MyApp.WebAuthnCallbackModule end If you're using Plug.Router : defmodule MyApp.Router do use Plug.Router forward &quot;/webauthn&quot; , to : WaxAPIREST.Plug , callback : MyApp.WebAuthnCallbackModule end Callback module An implementation of the WaxAPIREST.Callback module must be provided as an option or in the configuration file. Options In addition to Wax's options ( Wax.opt/0 ), the opts/0 can be used specifically with this plug. For instance, using Phoenix: defmodule MyApp.Router do use Phoenix.Router forward &quot;/webauthn&quot; , WaxAPIREST.Plug , [ callback_module : MyApp.WebAuthnCallbackModule , rp_name : &quot;My site&quot; , pub_key_cred_params : [ - 36 , - 35 , - 7 , - 259 , - 258 , - 257 ] # allows RSA algs ] end","ref":"WaxAPIREST.Plug.html","title":"WaxAPIREST.Plug","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"WaxAPIREST.Plug.html#call/2","title":"WaxAPIREST.Plug.call/2","type":"function"},{"doc":"","ref":"WaxAPIREST.Plug.html#callback_module/1","title":"WaxAPIREST.Plug.callback_module/1","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"WaxAPIREST.Plug.html#init/1","title":"WaxAPIREST.Plug.init/1","type":"function"},{"doc":"In addition to the Wax options, this library defines the following options: :callback_module [ mandatory ]: the callback module, no default :rp_name : a human-palatable identifier for the Relying Party . If not present, defaults to the RP id ( Wax option :rp_id ) :pub_key_cred_params : the list of allowed credential algorithms. Defaults to [-36, -35, -7] which are ES512, ES384 and ES256 in this order of precedence. These values have been chosen using the following security analysis: Security Concerns Surrounding WebAuthn: Don't Implement ECDAA (Yet) :attestation_conveyance_preference : the attestation conveyance preference. Defaults to the value of the request or, if absent, to &quot;none&quot; The options can be configured (in order of precedence): through options passed as a parameter to the plug router in the configuration file (under the WaxAPIREST key)","ref":"WaxAPIREST.Plug.html#t:opt/0","title":"WaxAPIREST.Plug.opt/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Plug.html#t:opts/0","title":"WaxAPIREST.Plug.opts/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.AttestationConveyancePreference.html","title":"WaxAPIREST.Types.AttestationConveyancePreference","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.AttestationConveyancePreference.html#new/1","title":"WaxAPIREST.Types.AttestationConveyancePreference.new/1","type":"function"},{"doc":"Must be one of: &quot;none&quot; &quot;indirect&quot; &quot;direct&quot;","ref":"WaxAPIREST.Types.AttestationConveyancePreference.html#t:t/0","title":"WaxAPIREST.Types.AttestationConveyancePreference.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.AuthenticatorAttachment.html","title":"WaxAPIREST.Types.AuthenticatorAttachment","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.AuthenticatorAttachment.html#new/1","title":"WaxAPIREST.Types.AuthenticatorAttachment.new/1","type":"function"},{"doc":"Must be either &quot;platform&quot; or &quot;cross-platform&quot;","ref":"WaxAPIREST.Types.AuthenticatorAttachment.html#t:t/0","title":"WaxAPIREST.Types.AuthenticatorAttachment.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.AuthenticatorSelectionCriteria.html","title":"WaxAPIREST.Types.AuthenticatorSelectionCriteria","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.AuthenticatorSelectionCriteria.html#new/1","title":"WaxAPIREST.Types.AuthenticatorSelectionCriteria.new/1","type":"function"},{"doc":"","ref":"WaxAPIREST.Types.AuthenticatorSelectionCriteria.html#t:t/0","title":"WaxAPIREST.Types.AuthenticatorSelectionCriteria.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.AuthenticatorTransport.html","title":"WaxAPIREST.Types.AuthenticatorTransport","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.AuthenticatorTransport.html#new/1","title":"WaxAPIREST.Types.AuthenticatorTransport.new/1","type":"function"},{"doc":"Must be one of: &quot;usb&quot; &quot;nfc&quot; &quot;ble&quot; &quot;internal&quot; &quot;lightning&quot;","ref":"WaxAPIREST.Types.AuthenticatorTransport.html#t:t/0","title":"WaxAPIREST.Types.AuthenticatorTransport.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.Error.html","title":"WaxAPIREST.Types.Error","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.PubKeyCredParams.html","title":"WaxAPIREST.Types.PubKeyCredParams","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.PubKeyCredParams.html#new/2","title":"WaxAPIREST.Types.PubKeyCredParams.new/2","type":"function"},{"doc":"","ref":"WaxAPIREST.Types.PubKeyCredParams.html#t:t/0","title":"WaxAPIREST.Types.PubKeyCredParams.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.PublicKeyCredentialRpEntity.html","title":"WaxAPIREST.Types.PublicKeyCredentialRpEntity","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.PublicKeyCredentialRpEntity.html#new/2","title":"WaxAPIREST.Types.PublicKeyCredentialRpEntity.new/2","type":"function"},{"doc":"","ref":"WaxAPIREST.Types.PublicKeyCredentialRpEntity.html#t:t/0","title":"WaxAPIREST.Types.PublicKeyCredentialRpEntity.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.PublicKeyCredentialType.html","title":"WaxAPIREST.Types.PublicKeyCredentialType","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.PublicKeyCredentialType.html#new/1","title":"WaxAPIREST.Types.PublicKeyCredentialType.new/1","type":"function"},{"doc":"Must be one of: &quot;public-type&quot;","ref":"WaxAPIREST.Types.PublicKeyCredentialType.html#t:t/0","title":"WaxAPIREST.Types.PublicKeyCredentialType.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.ResidentKeyRequirement.html","title":"WaxAPIREST.Types.ResidentKeyRequirement","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.ResidentKeyRequirement.html#new/1","title":"WaxAPIREST.Types.ResidentKeyRequirement.new/1","type":"function"},{"doc":"Must be one of: &quot;discouraged&quot;&quot; &quot;preferred&quot; &quot;required&quot;","ref":"WaxAPIREST.Types.ResidentKeyRequirement.html#t:t/0","title":"WaxAPIREST.Types.ResidentKeyRequirement.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.ServerAuthenticatorAssertionResponse.html","title":"WaxAPIREST.Types.ServerAuthenticatorAssertionResponse","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.ServerAuthenticatorAssertionResponse.html#new/1","title":"WaxAPIREST.Types.ServerAuthenticatorAssertionResponse.new/1","type":"function"},{"doc":"","ref":"WaxAPIREST.Types.ServerAuthenticatorAssertionResponse.html#t:t/0","title":"WaxAPIREST.Types.ServerAuthenticatorAssertionResponse.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.ServerAuthenticatorAttestationResponse.html","title":"WaxAPIREST.Types.ServerAuthenticatorAttestationResponse","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.ServerAuthenticatorAttestationResponse.html#new/1","title":"WaxAPIREST.Types.ServerAuthenticatorAttestationResponse.new/1","type":"function"},{"doc":"","ref":"WaxAPIREST.Types.ServerAuthenticatorAttestationResponse.html#t:t/0","title":"WaxAPIREST.Types.ServerAuthenticatorAttestationResponse.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredential.html","title":"WaxAPIREST.Types.ServerPublicKeyCredential","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredential.html#new/1","title":"WaxAPIREST.Types.ServerPublicKeyCredential.new/1","type":"function"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredential.html#t:t/0","title":"WaxAPIREST.Types.ServerPublicKeyCredential.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsRequest.html","title":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsRequest","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsRequest.html#new/1","title":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsRequest.new/1","type":"function"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsRequest.html#t:t/0","title":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsRequest.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsResponse.html","title":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsResponse","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsResponse.html#new/4","title":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsResponse.new/4","type":"function"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsResponse.html#t:t/0","title":"WaxAPIREST.Types.ServerPublicKeyCredentialCreationOptionsResponse.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialDescriptor.html","title":"WaxAPIREST.Types.ServerPublicKeyCredentialDescriptor","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialDescriptor.html#new/2","title":"WaxAPIREST.Types.ServerPublicKeyCredentialDescriptor.new/2","type":"function"},{"doc":"A tuple-based representation of t:ServerPublicKeyCredentialDescriptor/0 This representation is designed to make it easier to use it with an external data store such as a database, that has no knowledge of Elixir's data structures","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialDescriptor.html#t:flat/0","title":"WaxAPIREST.Types.ServerPublicKeyCredentialDescriptor.flat/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialDescriptor.html#t:t/0","title":"WaxAPIREST.Types.ServerPublicKeyCredentialDescriptor.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsRequest.html","title":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsRequest","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsRequest.html#new/1","title":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsRequest.new/1","type":"function"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsRequest.html#t:t/0","title":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsRequest.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsResponse.html","title":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsResponse","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsResponse.html#new/4","title":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsResponse.new/4","type":"function"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsResponse.html#t:t/0","title":"WaxAPIREST.Types.ServerPublicKeyCredentialGetOptionsResponse.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialUserEntity.html","title":"WaxAPIREST.Types.ServerPublicKeyCredentialUserEntity","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialUserEntity.html#new/3","title":"WaxAPIREST.Types.ServerPublicKeyCredentialUserEntity.new/3","type":"function"},{"doc":"","ref":"WaxAPIREST.Types.ServerPublicKeyCredentialUserEntity.html#t:t/0","title":"WaxAPIREST.Types.ServerPublicKeyCredentialUserEntity.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.UserVerificationRequirement.html","title":"WaxAPIREST.Types.UserVerificationRequirement","type":"module"},{"doc":"","ref":"WaxAPIREST.Types.UserVerificationRequirement.html#new/1","title":"WaxAPIREST.Types.UserVerificationRequirement.new/1","type":"function"},{"doc":"Must be one of: &quot;required&quot; &quot;preferred&quot; &quot;discouraged&quot;","ref":"WaxAPIREST.Types.UserVerificationRequirement.html#t:t/0","title":"WaxAPIREST.Types.UserVerificationRequirement.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.Error.InvalidField.html","title":"WaxAPIREST.Types.Error.InvalidField","type":"exception"},{"doc":"","ref":"WaxAPIREST.Types.Error.InvalidField.html#t:t/0","title":"WaxAPIREST.Types.Error.InvalidField.t/0","type":"type"},{"doc":"","ref":"WaxAPIREST.Types.Error.MissingField.html","title":"WaxAPIREST.Types.Error.MissingField","type":"exception"},{"doc":"","ref":"WaxAPIREST.Types.Error.MissingField.html#t:t/0","title":"WaxAPIREST.Types.Error.MissingField.t/0","type":"type"},{"doc":"REST API for Wax A plug that exposes the FIDO2 REST API 7. Transport Binding Profil . This Plug has been created mainly for use by WaxFidoTestSuiteServer , but could be useful for those who want to implement WebAuthn authentication using javascript to retrieve challenges. Feedback would be appreciated, especially on the callback module.","ref":"readme.html","title":"WaxAPIREST","type":"extras"},{"doc":"def deps do [ { :wax_api_rest , &quot;~&gt; 0.3.0&quot; } ] end","ref":"readme.html#installation","title":"WaxAPIREST - Installation","type":"extras"},{"doc":"In a Phoenix router, forward a route to the WaxAPIREST.Plug : defmodule MyApp.Router do use Phoenix.Router forward &quot;/webauthn&quot; , WaxAPIREST.Plug , callback : MyApp.WebAuthnCallbackModule end If you're using Plug.Router : defmodule MyApp.Router do use Plug.Router forward &quot;/webauthn&quot; , to : WaxAPIREST.Plug , callback : MyApp.WebAuthnCallbackModule end","ref":"readme.html#usage","title":"WaxAPIREST - Usage","type":"extras"},{"doc":"An implementation of the WaxAPIREST.Callback module must be provided as an option or in the configuration file. This callback is responsible for: returning the current user's information (id, display name...) returning the current user's registered WebAuthn keys saving backend (for instance in the cookie session) registering new WebAuthn keys setting authentication status once authenticated Refer to the callback module for more information. An example implementation can be found in the WaxFidoTestSuiteServer project (but don't use it as-is).","ref":"readme.html#callback-module","title":"WaxAPIREST - Callback module","type":"extras"},{"doc":"In addition to Wax's options ( Wax.opt/0 ), the following options can be used specifically with this plug: :callback_module [ mandatory ]: the callback module :rp_name : a human-palatable identifier for the Relying Party . If not present, defaults to the RP id ( Wax option :rp_id ) :pub_key_cred_params : the list of allowed credential algorithms. Defaults to [-36, -35, -7] which are ES512, ES384 and ES256 in this order of precedence. These values have been chosen using the following security analysis: Security Concerns Surrounding WebAuthn: Don't Implement ECDAA (Yet) :attestation_conveyance_preference : the attestation conveyance preference. Defaults to the value of the request or, if absent, to &quot;none&quot; For instance, using Phoenix: defmodule MyApp.Router do use Phoenix.Router forward &quot;/webauthn&quot; , WaxAPIREST.Plug , [ callback_module : MyApp.WebAuthnCallbackModule , rp_name : &quot;My site&quot; , pub_key_cred_params : [ - 36 , - 35 , - 7 , - 259 , - 258 , - 257 ] # allows RSA algs ] end See WaxAPIREST.Plug.opt/0 for more information, including option precedence rules.","ref":"readme.html#options","title":"WaxAPIREST - Options","type":"extras"}]